use DataScience
go


--Here is a recursive solution:

drop function if exists dbo.factorial
go 

create function dbo.factorial ( @inumber int )
returns bigint
as
begin
declare @i bigint

	iF @inumber = 0
        set @i = 1
    else
        set @i = @inumber * dbo.Factorial( @inumber - 1 )

return (@i)
end
go


-- show sample results from dbo.factorial
declare @inumber int

-- factorial results for legitimate inputs
set @inumber = 0; select @inumber N, dbo.factorial(@inumber) [factorial value]
set @inumber = 1; select @inumber N, dbo.factorial(@inumber) [factorial value]
set @inumber = 2; select @inumber N, dbo.factorial(@inumber) [factorial value]
set @inumber = 3; select @inumber N, dbo.factorial(@inumber) [factorial value]
set @inumber = 9; select @inumber N, dbo.factorial(@inumber) [factorial value]
set @inumber = 10; select @inumber N, dbo.factorial(@inumber) [factorial value]
set @inumber = 20; select @inumber N, dbo.factorial(@inumber) [factorial value]

-- factorial results for illegitimate inputs
set @inumber = -1; select @inumber N, dbo.factorial(@inumber) [factorial value]
go
declare @inumber int
set @inumber = 21; select @inumber N, dbo.factorial(@inumber) [factorial value]



drop function if exists dbo.factorialfunction
go 

create function dbo.factorialfunction ( @inumber int )
returns bigint
as
begin
declare @i bigint

	if @inumber < 0 or @inumber > 20
		set @i = NULL
	else
		set @i = (select dbo.Factorial(@inumber))

return (@i)
end
go


-- show sample results from dbo.factorialfunction
declare @inumber int

-- factorial results for legitimate inputs
set @inumber = 0; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]
set @inumber = 1; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]
set @inumber = 2; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]
set @inumber = 3; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]
set @inumber = 9; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]
set @inumber = 10; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]
set @inumber = 20; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]

-- factorial results for illegitimate inputs
set @inumber = -1; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]
set @inumber = 21; select @inumber N, dbo.factorialfunction(@inumber) [factorial value]

